???File Path
==========
***...\ClientApp\srcpp\src\accounts\cheque-print-settings\cheque-print-settings.component.ts


???Check the points
==================
1) Check ...\ClientApp\srcpp\srcaseranchranch.component.ts and ...\ClientApp\srcpp\srcase\company\company.component.ts 
2) Main Grouping Must
	-> // @@@@@@@ AREA=> FROM HTML INPUT AREA Called Functions(Not Button bar and List) @@@@@@@@@@@@@@
	-> // @@@@@@@ FROM HTML MAIN LIST Called Functions @@@@@@@@@@@@@@
	-> // @@@@@@@ AREA=> FROM HTML BUTTON BAR Called Functions @@@@@@@@@@@@@@
	-> // @@@@@@@ AREA=> COMMON Functions @@@@@@@@@@@@@@
3) Set GUI Heading in constructor(Eg:- insGlobalConstants.strGuiHeading = "***";)
4) Set GUI/Menu System Name in constructor(Eg:- insGlobalConstants.strSysModuleName = "***";) based on menu service
5) Set GUI Tittle(Browser Tab) in constructor(Eg:- insGlobalFunctions.fnSetGuiBasedBrowserTitle = "***";)



            // ??? Check and Use If you need...
            //---------------------------------
            import { Component, OnInit, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
            import { DxDataGridComponent } from "devextreme-angular";

            import * as globalConstantsService from '../../../services/global-constants.service';
            import * as globalFunctionsService from '../../../services/global-functions.service';
            import * as globalDataService from '../../../services/global-data.service';
            import * as baseDataService from '../../../services/base/base-data.service';
            import * as jspdfService from '../../../services/jspdf.service';
            import * as menuService from '../../../services/menu.service';
            import { MdlChequePrintSettings, MdlReqChequePrintSettings, MdlResChequePrintSettings, MdlResChequePrintSettingsInit, MdlResChequePrintSettingsList } from '../../../models/accounts/paidcheque.model';
            import { MdlResponse, MdlBaseIntId, MdlReqBaseIntId } from "../../../models/common.model";
            import { HttpService } from '../../../services/http.service';
        


            // ??? Check and Use If you need...
            //---------------------------------
            export class ChequePrintSettingsComponent implements OnInit, AfterViewInit, OnDestroy {
                // ** initialize data
                public mdlChequePrintSettings: MdlChequePrintSettings = new MdlChequePrintSettings();
                public intActiveChequePrintSettingsIndex: number = -1;
                // ** Select and Auto-completion
                // ??? Remove not use items !!!

                // ** GUI Control
                public blnBtnDisabled: boolean = false;
                public blnMoreDivExpanded: boolean = false;
                // ** ChequePrintSettings List
                @ViewChild('#idDgChequePrintSettingsList') idDgChequePrintSettingsList!: DxDataGridComponent;
                public lstAllChequePrintSettings: MdlChequePrintSettings[] = [];
                public blnDgChequePrintSettingsShowFilterRow: boolean = false;
                public blnDgChequePrintSettingsHeaderFilter: boolean = false;
                public intActiveChequePrintSettingsListItemIndex = -1;
        


                // ??? If you need, import and create instance other common classes !!!
                constructor(public insGlobalConstants: globalConstantsService.GlobalConstantsService,
                        public insGlobalFunctions: globalFunctionsService.GlobalFunctionsService,
                        public insGlobalData: globalDataService.GlobalDataService,
                        public insBaseData: baseDataService.BaseDataService,
                        private insHttpService: HttpService,
                        public insJspdf: jspdfService.JspdfService) {
    
                    insGlobalConstants.strGuiHeading = 'chequePrintSettings';
                    // ??? Check menu service !!!
                    insGlobalConstants.strSysModuleName = "CHEQUEPRINTSETTINGS_MASTER";
                    insGlobalFunctions.fnSetGuiBasedBrowserTitle("ChequePrintSettings");
                }

                ngOnInit(): void {
                    this.blnBtnDisabled = true;
                    document.body.style.cursor = "wait";

                    this.fnDefaultView();

                    // initialize Data Request
                    this.insHttpService.get('Base/Organization/GetChequePrintSettingsInitializeData')
                    .then((mdlResChequePrintSettingsInit: MdlResChequePrintSettingsInit) => {
                        if (mdlResChequePrintSettingsInit.sinStatus == 1) {
                            this.lstMdlChequePrintSettings = mdlResChequePrintSettingsInit.lstMdlChequePrintSettings;

                            // ??? Remove not use items !!!

                        } else {
                            console.log(mdlResChequePrintSettingsInit.strMessage + " => " + mdlResChequePrintSettingsInit.strErrorCode + ' -> ' + mdlResChequePrintSettingsInit.strSysError);
                        }
                    })
                    .catch((err: any) => {
                        console.log("Error->CHEQUEPRINTSETTINGS.COMPONENT.TS#001: " + JSON.stringify(err));
                    });

                    document.body.style.cursor = "default";
                    this.blnBtnDisabled = false;
                }

                ngAfterViewInit(): void {
                }

                ngOnDestroy() {
                }
        


            // @@@@@@@ AREA=> FROM HTML INPUT AREA Called Functions(Not Button bar and List) @@@@@@@@@@@@@


            // ??? AUTO/ENTRY COMPLETE - Set Id[, Code, Name] -> OnFocusOut Event

            // ??? Any caculation/Display Based on user inputs

        


            // @@@@@@@@@@@@@@@@@@@@@@@ AREA=> FROM HTML MAIN LIST Called Functions @@@@@@@@@@@@@@@@@@@@@@@@

            fnOnChequePrintSettingsListEditButtonClick(objSelRow: any) {
                this.blnBtnDisabled = true;
                document.body.style.cursor = "wait";

                this.fnSetDataAndGuiEditMode(objSelRow.row.data, objSelRow.row.rowIndex);

                document.body.style.cursor = "default";
                this.blnBtnDisabled = false;
            }

            fnOnChequePrintSettingsListRowDblClick(objDblClickRowData: any) {
                this.blnBtnDisabled = true;
                document.body.style.cursor = "wait";

                this.fnSetDataAndGuiEditMode(objDblClickRowData.data, objDblClickRowData.rowIndex);

                document.body.style.cursor = "default";
                this.blnBtnDisabled = false;
            }

            fnOnDgFilterRowEnableDisableClick() {
                this.blnDgShowFilterRow = !this.blnDgShowFilterRow;
            }

            fnOnDgHeadeFilterEnableDisableClick() {
                this.blnDgHeaderFilter = !this.blnDgHeaderFilter;
            }
        


            // @@@@@@@@@@@@@@@@@@@@@@ AREA=> FROM HTML BUTTON BAR Called Functions @@@@@@@@@@@@@@@@@@@@@@@@

            async fnOnSaveButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";
            this.fnDefaultView(false, true, true, false);

            // Add or Update 
            try {
            // Input Validation
            this.fnInputValidation(this.mdlChequePrintSettings);

            // Input Data set
            //....

            // Set Save Request Inputs
            let mdlReqChequePrintSettings: MdlReqChequePrintSettings = new MdlReqChequePrintSettings();
            mdlReqChequePrintSettings.mdlChequePrintSettings = JSON.parse(JSON.stringify(this.mdlChequePrintSettings));

            // Request Data Reset
            //....

            // Save Request
            await this.insHttpService.post('Base/Organization/SaveChequePrintSettings', mdlReqChequePrintSettings)
                .then((mdlResChequePrintSettings: MdlResChequePrintSettings) => {
                if (mdlResChequePrintSettings.sinStatus == 1) {
                    this.mdlChequePrintSettings = mdlResChequePrintSettings.mdlChequePrintSettings;
                    if (this.intActiveChequePrintSettingsIndex == -1) {
                    // New Item
                    this.intActiveChequePrintSettingsIndex = this.lstMdlChequePrintSettings.length;
                    this.lstMdlChequePrintSettings.push(JSON.parse(JSON.stringify(this.mdlChequePrintSettings)));
                    }
                    else {
                    // Update
                    this.lstMdlChequePrintSettings[this.intActiveChequePrintSettingsIndex] = JSON.parse(JSON.stringify(this.mdlChequePrintSettings));
                    //this.lstMdlChequePrintSettings.splice(this.intActiveChequePrintSettingsIndex, 1, this.mdlChequePrintSettings);
                    }

                    this.insGlobalConstants.fnSetSuccessMessage(mdlResChequePrintSettings.strMessage);
                } else {
                    this.insGlobalConstants.fnSetErrorMessage(mdlResChequePrintSettings.strMessage, mdlResChequePrintSettings.strSysError);
                    console.log(mdlResChequePrintSettings);
                }
                })
                .catch((err: any) => {
                    this.insGlobalConstants.fnSetErrorMessage(JSON.stringify(err));
                });

            } catch (ex: unknown) {
                if (ex instanceof Error) {
                    //this.insGlobalConstants.strErrorMessages = ex.message;
                    this.insGlobalConstants.fnSetErrorMessage(ex.message);
                }
                console.log("Error->CHEQUEPRINTSETTINGS.COMPONENT.TS#002: " + ex);
            }

            this.fnDefaultView(false, false, true, false);
            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        fnOnNewButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";

            this.fnDefaultView(true, true, true, false);

            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        async fnOnDeleteButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";
            this.fnDefaultView(false, true, false, false);

            // Delete 
            try {

            // Input Validation
            if (this.mdlChequePrintSettings.binChequePrintSettingsId == null || this.mdlChequePrintSettings.binChequePrintSettingsId < 1) {
                throw new Error('Select ChequePrintSettings for DELETE.');
            }

            // Set Delete Request Inputs
            let mdlReqChequePrintSettingsBaseIntId: MdlReqBaseIntId = new MdlReqBaseIntId();
            mdlReqChequePrintSettingsBaseIntId.mdlBaseIntId.binPkId = this.mdlChequePrintSettings.binChequePrintSettingsId;
            mdlReqChequePrintSettingsBaseIntId.mdlBaseIntId.binCustomValue = this.mdlChequePrintSettings.intSysActionId;
            
            // Delete Request
            await this.insHttpService.post('Base/Organization/DeleteChequePrintSettings', mdlReqChequePrintSettingsBaseIntId)
                .then((mdlResponse: MdlResponse) => {
                if (mdlResponse.sinStatus == 1) {
                    this.lstMdlChequePrintSettings.splice(this.intActiveChequePrintSettingsIndex, 1);
                    this.fnDefaultView(true, false, false, false);
                    this.insGlobalConstants.fnSetSuccessMessage(mdlResponse.strMessage);
                } else {
                    this.insGlobalConstants.fnSetErrorMessage(mdlResponse.strMessage, mdlResponse.strSysError);
                    console.log(mdlResponse);
                }
                })
                .catch((err: any) => {
                this.insGlobalConstants.fnSetErrorMessage(JSON.stringify(err));
                });

            } catch (ex: unknown) {
            if (ex instanceof Error) {
                this.insGlobalConstants.fnSetErrorMessage(ex.message);
            }
            console.log("Error->CHEQUEPRINTSETTINGS.COMPONENT.TS#003: " + ex);
            }

            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        


            // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ AREA=> COMMON Functions @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


            fnDefaultView(blnClearData: boolean = true, blnClearMessages: boolean = true, blnMoreDivExpanded: boolean = false, blnGotoBottom: boolean = false) {
                if (blnClearData) {
                    this.mdlChequePrintSettings = new MdlChequePrintSettings();
                    this.intActiveChequePrintSettingsIndex = -1;
                }

                this.blnMoreDivExpanded = blnMoreDivExpanded;

                if (blnClearMessages) {
                    this.insGlobalConstants.strErrorMessages = "";
                    this.insGlobalConstants.strSuccessMessages = "";
                }
                
                if (!blnGotoBottom)
                    this.insGlobalFunctions.fnWindowScrollTop();
                else {
                    this.insGlobalFunctions.fnWindowScrollbottom();
                }
            }

            fnSetDataAndGuiEditMode(mdlChequePrintSettings: MdlChequePrintSettings, intRowIndex: number) {
                this.mdlChequePrintSettings = JSON.parse(JSON.stringify(mdlChequePrintSettings));
                this.intActiveChequePrintSettingsIndex = intRowIndex;
                this.fnDefaultView(false, true, true, false);
            }

            fnInputValidation(mdlChequePrintSettings: MdlChequePrintSettings) {
                // ??? CHECK
                
                if (mdlChequePrintSettings.strChequePrintName == "") {
                    throw new Error('Enter/Select Cheque Print Name.');
                }
            
                if (mdlChequePrintSettings.strSysChequePrintName == "") {
                    throw new Error('Enter/Select Sys Cheque Print Name.');
                }
            

                // ??? CHECK CODE and NAME [Other UNIQUE Fields] Already exists
            }
        

